#!/bin/bash
# install script for cvsd
SRCDIR=$PWD
install -m755 cvsd /usr/local/sbin
if ! grep -q cvsowner /etc/passwd ; then
	echo "Creating cvsowner, group cvsadmin, and setting up /home/cvsowner..."
	mkdir /home/cvsowner
	groupadd -g 2401 cvsadmin
	useradd -u 2401 -g 2401 -c "CVS UID" -m -k /home/cvsowner -G cvsadmin cvsowner
	chown -R cvsowner.cvsadmin /home/cvsowner
fi
if [ ! -f /home/cvsowner/cvsd-root ] ; then
	echo "Setting up /home/cvsowner/cvsd-root..."
	cd /home/cvsowner
	mkdir cvsd-root
	cd cvsd-root
	mkdir etc bin lib tmp dev cvsroot
	cd /lib
	install -m755 `ldd /usr/bin/cvs | cut -d " " -f 1` /lib/libnss_files.so.1 /usr/lib/libz.so.1 /home/cvsowner/cvsd-root/lib/
	install -m755 /usr/bin/cvs /home/cvsowner/cvsd-root/bin/
	install -m644 $SRCDIR/cvsd-passwd /home/cvsowner/cvsd-root/etc/passwd
	install -m600 $SRCDIR/cvsd.conf /etc/cvsd.conf
	chown -R cvsowner.cvsadmin /home/cvsowner
	mknod /home/cvsowner/cvsd-root/dev/null c 1 3
fi
if ! grep -q cvspserver /etc/services ; then
	echo "no existing cvspserver line in /etc/services, adding..."
	echo -e "cvspserver\t2401/tcp\t\t# CVS pserver auth" >> /etc/services
fi
if ! grep -q cvspserver /etc/inetd.conf ; then
	echo "no existing cvspserver line in /etc/inetd.conf, adding..."
	echo -e "cvspserver\tstream\ttcp\tnowait\troot\t/usr/local/sbin/cvsd\tcvsd" >> /etc/inetd.conf
fi
echo "Now check out /etc/cvsd.conf, restart inetd (killall -HUP inetd), and "
echo "initialise the repository using: "
echo "\"cvs -d :pserver:user@localhost:/cvsroot init\" "
echo "Password is \"pass\" "
echo "Also edit/modify/whatever the /home/cvsowner/cvsd-root/etc/passwd file."
echo "Default user/passwds are cvs/cvs (for ro anon), user/pass. Change these!"
